'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Util = function () {
  function Util() {
    _classCallCheck(this, Util);
  }

  Util.parseQueryJson = function parseQueryJson(url) {
    var arr = []; // 存储参数的数组
    var res = {}; // 存储最终JSON结果对象
    arr = url.split('&'); // 获取浏览器地址栏中的参数
    for (var i = 0; i < arr.length; i++) {
      // 遍历参数
      if (arr[i].indexOf('=') != -1) {
        // 如果参数中有值
        var str = arr[i].split('=');
        res[str[0]] = str[1];
      } else {
        // 如果参数中无值
        res[arr[i]] = '';
      }
    }
    return res;
  };
  // 判断是否为Android


  Util.checkIsAndroid = function checkIsAndroid() {
    if (window.navigator.userAgent.match(/android/i)) {
      return true;
    }
    return false;
  };
  // 执行客户端指令


  Util.executeCmd = function executeCmd(str) {
    if (this.checkIsAndroid()) {
      if (window.jsInterface) {
        console.log(str);
        window.jsInterface.execute(str);
      }
    } else {
      if (window.webkit) {
        var oQuery = this.parseQueryJson(str);
        var cmd = oQuery.cmd;
        delete oQuery.cmd;
        console.log('window.webkit.messageHandlers[' + cmd + '].postMessage(' + JSON.stringify(oQuery) + ')');
        window.webkit.messageHandlers[cmd].postMessage(JSON.stringify(oQuery));
      } else {
        console.log(str);
        window.location.href = 'js2oc://?' + str;
      }
    }
  };

  return Util;
}();