'use strict';

$(function () {
  FastClick.attach(document.body);
});
var collins = {
  init: function init() {
    var _this = this;
    _this.lastValue;
    _this.selRange;
    _this.isResume = false;
    _this.OFFSET_TOP = 22;
    template.defaults.debug = true;
    // 是否为英文字母
    var isAlpha = function isAlpha(str) {
      return (/[a-zA-Z']+/.test(str)
      );
    };
    // 点击选中,解决iOS12以及以下点击不能选中问题
    var hammer = new Hammer(document, {});
    hammer.on('tap', function (event) {
      var clientX = event.clientX || event.center.x;
      var clientY = event.clientY || event.center.y;
      var oRange = document.caretRangeFromPoint(clientX, clientY);
      var so = oRange.startOffset;
      var eo = oRange.endOffset;
      var tr = oRange.cloneRange();
      var text = '';
      if (oRange.startContainer.data) while (so >= 1) {
        tr.setStart(oRange.startContainer, --so);
        text = tr.toString();
        if (!isAlpha(text.charAt(0))) {
          tr.setStart(oRange.startContainer, so + 1);
          break;
        }
      }
      if (oRange.endContainer.data) while (eo < oRange.endContainer.data.length) {
        tr.setEnd(oRange.endContainer, ++eo);
        text = tr.toString();
        if (!isAlpha(text.charAt(text.length - 1))) {
          tr.setEnd(oRange.endContainer, eo - 1);
          break;
        }
      }
      var word = tr.toString();
      var oTarget = event.target;
      var $target = $(oTarget);
      //忽略一些标签
      if ($target.is('.def-container h3') || $target.is('body') || $target.is('xrparent a') || $target.is('.xref-wrap xref xrhw') || $target.is('.def-wrap xref xrhw') || $target.is('popup xrhw') || $target.is('popup') || $target.is('.head-word .word-text') || $target.is('.head-word .phonetic')) {
        return false;
      }
      var $children = $target.children();
      // 点击父级不选中单词
      if ($children.length > 0) {
        var hasWord = false;
        for (var i = 0; i < $children.size(); i++) {
          var $child = $children.eq(i);
          var _text = $child.text();
          if (_text === word) {
            hasWord = true;
            break;
          }
        }
        if (hasWord) {
          return false;
        }
      }
      if (word.length >= 1) {
        var s = window.getSelection();
        s.removeAllRanges();
        s.addRange(tr);
        event.preventDefault();
        return false;
      }
    });
    // iOS 8hack
    var oMatch = window.navigator.userAgent.match(/os\s+(\d+)/i);
    if (oMatch && oMatch[1] - 0 < 9) {
      $('#ios8').html('.def-wrap,.xref-wrap,.header-basic-entry .head-word,.exam-wrap li{overflow:hidden;}.xref-wrap .def,.xref-wrap def,.xref-wrap .tran,.def-wrap .def,.def-wrap def,.def-wrap .tran{display:block;}.xref-wrap def,.def-wrap def,.header-basic-entry .head-word hw,.header-basic-entry .head-word .word,.exam-wrap li p{padding-top:100px;margin-top:-100px;}');
    }
    // 点击弹出 - sense1第一条释义
    function popupWord(word, position) {
      var oWord = JSON.stringify({
        word: word,
        position: position
      });
      /*<android>*/
      window.jsInterface && window.jsInterface.execute('cmd=pop_word&word=' + word + '&position=' + position);
      /*</android>*/
    }
    // ex word:a
    $(document).on('touchend', 'xrparent a', function (event) {
      // var word = $(this).html();
      var word = $(this).contents().filter(function () {
        return this.nodeType != 1;
      }).text();
      var $sup = $(this).find('sup');
      var position = '';
      if ($sup.length) {
        position = $sup.html();
      }
      popupWord(word, position);
      event.preventDefault();
      return false;
    });
    // ex word -> xref-wrap xref:a
    $(document).on('touchend', '.xref-wrap xref,.def-wrap xref,popup', function (event) {
      var word = $(this).find('xrhw').html();
      var $xrhn = $(this).parent().find('xrhn');
      var position = '';
      if ($xrhn.length) {
        position = $xrhn.html();
      }
      popupWord(word, position);
      event.preventDefault();
      return false;
    });
    // ex word -> 点击发音
    $(document).on('touchend', '.head-word .word-text,.head-word .phonetic', function (event) {
      var word = $('.head-word .word-text').eq(0).html();
      /*<android>*/
      window.jsInterface && window.jsInterface.execute('cmd=voice_word&word=' + word);
      /*</android>*/
      event.preventDefault();
      return false;
    });
    //点击跳转
    $(document).on('touchend', '#superHeadwordContainer li', function (event) {
      var href = $(this).attr('data-go');
      var toT = $(href).offset().top - _this.OFFSET_TOP - collins.scrollTopGap;
      toT = Math.round(toT);
      /*<android>*/
      window.jsInterface.execute('cmd=scrollTo&offsetTop=' + toT);
      /*</android>*/
      event.preventDefault();
      return false;
    });
    function postSelectionChange() {
      if (window.getSelection().toString() && _this.lastValue != window.getSelection().toString()) {
        var rect = collins.getSelectionRect();
        // document.querySelector(".super-headword-container").innerHTML = JSON.parse(rect).content + (index++);
        _this.lastValue = window.getSelection().toString();
        _this.selRange = window.getSelection().getRangeAt(0);
        /*<android>*/
        window.jsInterface && window.jsInterface.execute('cmd=selectionChange&rect=' + rect);
        /*</android>*/
      } else {
        _this.lastValue = '';
      }
    }
    // selectionChange
    var moveTimer = null;
    function selectionChange() {
      if (_this.isResume) {
        setTimeout(function () {
          _this.isResume = false;
        }, 100);
        return;
      }
      moveTimer && clearTimeout(moveTimer);
      moveTimer = setTimeout(function () {
        postSelectionChange();
      }, 300);
    }
    // 会导致重复发音，以前长按查词才需要使用
    // document.addEventListener('selectionchange', selectionChange, false);
    document.addEventListener('touchstart', function () {
      window.getSelection().removeAllRanges();
      document.removeEventListener('selectionchange', selectionChange, false);
      if (window.navigator.userAgent.match(/Android 8/)) {
        document.addEventListener('selectionchange', fixPixel, false);
      }
    });
    document.addEventListener('touchmove', function () {
      document.removeEventListener('selectionchange', selectionChange, false);
    });
    document.addEventListener('touchend', function (event) {
      collins.doTouchEnd();
      // 去掉android选择菜单
      event.preventDefault();
    });
    this.doTouchEnd = function () {
      // postSelectionChange();
      document.addEventListener('selectionchange', selectionChange, false);
      if (window.navigator.userAgent.match(/Android 8/)) {
        document.removeEventListener('selectionchange', fixPixel, false);
      }
    };
    // fix pixel android8.0机器中的 12个空格导致全选bug(通过模拟 - 屏蔽第二次的全选事件)
    var lastTime;
    var lastRange;
    function fixPixel(ev) {
      var now = new Date().valueOf();
      var selection = window.getSelection();
      if (selection.rangeCount !== 1) {
        return;
      }
      var range = selection.getRangeAt(0);
      var text = range.toString();
      var matches = text.match(/\s/);
      if (lastTime && now - lastTime < 300) {
        if (matches && lastRange) {
          selection.removeAllRanges();
          selection.addRange(lastRange);
        } else if (matches) {
          selection.removeAllRanges();
        }
      } else if (matches) {
        selection.removeAllRanges();
      }
      lastTime = now;
      if (!matches) {
        lastRange = range;
        return;
      }
    }
  },
  render: function render(json, position, offsetTop, scrollTopGap) {
    var _this = this;
    var oBody = document.querySelector('body');
    // iOS需要设置顶部空白距离
    offsetTop && (oBody.style.paddingTop = offsetTop + 'px');
    // iOS需要偏移拖拽控件距离
    this.scrollTopGap = scrollTopGap ? scrollTopGap : 0;
    try {
      if (typeof json == 'string') {
        json = JSON.parse(json);
      }
      var html = template('tpl', json);
      setTimeout(function () {
        oBody.innerHTML = html;
        // 渲染后定位，柯林斯页面 蓝色链接点击全屏展开
        if (position) {
          var href = $('#superHeadword' + (position - 1));
          var toT = $(href).offset().top - _this.OFFSET_TOP - collins.scrollTopGap;
          // __JUMPTO
          toT = Math.round(toT);
          /*<android>*/
          window.jsInterface.execute('cmd=scrollTo&offsetTop=' + toT);
          /*</android>*/
          return false;
        }
        //屏幕高度如果一屏能显示 如air strike，防止出现回到顶部
        var iScrollHeight = document.documentElement.scrollHeight;
        var iWinHeight = document.documentElement.clientHeight;
        if (iScrollHeight - iWinHeight < 52) {
          $('#mainContainer').css('padding-bottom', '20');
        }
        /*<android>*/
        window.jsInterface && window.jsInterface.execute('cmd=render_done');
        /*</android>*/
      }, 0);
    } catch (err) {
      /*<android>*/
      var sErr = err + '';
      window.jsInterface && window.jsInterface.execute('cmd=render_done&error=' + sErr);
      console.log(err);
      /*</android>*/
    }
  },
  getSelectionRect: function getSelectionRect() {
    var json = {};
    var oSelection = window.getSelection();
    if (oSelection.toString()) {
      var selectRect = oSelection.getRangeAt(0).getBoundingClientRect();
      json.top = selectRect.top;
      json.right = selectRect.right;
      json.bottom = selectRect.bottom;
      json.left = selectRect.left;
      json.content = oSelection.toString().replace(/(^'|'$)/g, '');
      return JSON.stringify(json);
    }
  },
  removeSelection: function removeSelection() {
    collins.lastValue = '';
    window.getSelection().removeAllRanges();
  },
  resumeSelection: function resumeSelection() {
    window.getSelection().removeAllRanges();
    collins.isResume = true;
    window.getSelection().addRange(collins.selRange);
  },
  clearRenderContent: function clearRenderContent() {
    document.querySelector('body').innerHTML = '';
  },
  setHeadGap: function setHeadGap(iGap) {
    document.querySelector('body').style.paddingTop = iGap + 'px';
  },
  setFootGap: function setFootGap(iGap) {
    document.querySelector('body').style.paddingBottom = iGap + 'px';
  },
  //设置主题
  setTheme: function setTheme(theme) {
    $('body').attr('class', '').addClass(theme);
  },
  // 设置字体
  setFontFamily: function setFontFamily(fontFamily) {
    // $("#fontFamily").text(".header-basic-entry .head-word .word,.header-basic-entry .head-word hw {font-family: " + fontFamily + ";}")
  }
};
collins.init();