'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

$(function () {
  var MIN_PAGE = 1; //最小页码
  FastClick.attach(document.body);
  /**
   * 真题类
   */

  var Exam = function (_General) {
    _inherits(Exam, _General);

    // 构造函数
    function Exam() {
      _classCallCheck(this, Exam);

      // 查词
      var _this = _possibleConstructorReturn(this, _General.call(this));

      _this.dataBody = {};
      _this.tabsBody = {
        exam_tabs: [{
          code: 'CET4',
          name: '四级'
        }, {
          code: 'CET6',
          name: '六级'
        }, {
          code: 'KY',
          name: '考研'
        }]
      };
      _this.loading = false;
      _General.prototype.onSelectWord.call(_this);
      _this.loadingMore();
      _this.onTab();
      window.onresize = function () {
        _this.setTabsGap();
      };
      return _this;
    }

    Exam.prototype.doTouchEnd = function doTouchEnd() {};
    // 加载更多


    Exam.prototype.loadingMore = function loadingMore() {
      var _this2 = this;

      window.onscroll = function () {
        //文档内容实际高度（包括超出视窗的溢出部分）
        var scrollHeight = Math.max(document.documentElement.scrollHeight, document.body.scrollHeight);
        //滚动条滚动距离
        var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
        //窗口可视范围高度
        var clientHeight = window.innerHeight || Math.min(document.documentElement.clientHeight, document.body.clientHeight);
        var GAP = 80; //距离底部距离
        if (clientHeight + scrollTop >= scrollHeight - GAP) {
          // 加载中，防抖，禁止频繁加载
          if (_this2.loading) {
            return;
          }
          _this2.loading = true;
          setTimeout(function () {
            _this2.loading = false;
          }, 1000);
          var type = _this2.dataBody.type;
          if (type) {
            var pageInfo = _this2.dataBody.pageInfo;
            var currentPage = pageInfo.currentPage;
            if (currentPage === pageInfo.totalPage) {
              return;
            }
            console.log('===加载更多内容……===');
            $('#loadingWrap').show();
            var cmd = 'cmd=requestRenderExam&type=' + type + '&page=' + (currentPage + 1);
            Util.executeCmd(cmd);
          }
        }
      };
    };
    // 点击tab


    Exam.prototype.onTab = function onTab() {
      var that = this;
      $(document).on('touchend', '.tags-wrap li', function () {
        $('.tags-wrap li').removeClass('on');
        $(this).addClass('on');
        that.clearContentTimer = setTimeout(function () {
          $('.content-container').html('');
        }, 500);
        var type = $(this).attr('data-type');
        var currentTab = that.getCurrentTab(type);
        // 提示消息,渲染
        if (currentTab.show_msg) {
          that.render({}, type);
        }
        var cmd = 'cmd=requestRenderExam&type=' + type + '&page=1';
        Util.executeCmd(cmd);
      });
    };
    // 设置tabs间距


    Exam.prototype.setTabsGap = function setTabsGap() {
      var MIN_GAP = 12;
      var $tagsWrap = $('.tags-wrap');
      var parentWidth = $tagsWrap.width();
      var $li = $tagsWrap.find('li');
      var iTabWidth = $li.width();
      var iRowMax = parseInt(parentWidth / (iTabWidth + MIN_GAP)); //一行最大个数
      // 超过一行两端对齐，hack来源于 https://www.zhangxinxu.com/wordpress/2019/08/css-flex-last-align/
      if ($li.length >= iRowMax) {
        $tagsWrap.css({ justifyContent: 'space-between' });
        // const gap = (parentWidth / iRowMax - iTabWidth) / 2;
        // $li.css({marginLeft: gap, marginRight: gap});
      } else {
        $tagsWrap.css({ justifyContent: 'flex-start' });
      }
    };
    /**
     * 渲染标签
     * @param jsonString {String | Object}
     */


    Exam.prototype.renderTabs = function renderTabs(jsonString) {
      var oContent = jsonString;
      if (typeof jsonString === 'string') {
        oContent = JSON.parse(jsonString);
      }
      if (oContent.exam_tabs) {
        this.tabsBody = oContent;
      }
    };
    /**
     * 获取选中的tab对象
     * @param type
     */


    Exam.prototype.getCurrentTab = function getCurrentTab(type) {
      var examTabs = this.tabsBody.exam_tabs;
      if (examTabs) {
        for (var _iterator = examTabs, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
          var _ref;

          if (_isArray) {
            if (_i >= _iterator.length) break;
            _ref = _iterator[_i++];
          } else {
            _i = _iterator.next();
            if (_i.done) break;
            _ref = _i.value;
          }

          var ele = _ref;

          if (ele.code === type) {
            return ele;
          }
        }
      }
      return {};
    };
    /**
     *
     * @param {String | Object} jsonString
     * @param {String} type (CET4 | CET6 | KY)
     * @param {Number} headerOffsetTop iOS头部偏移
     */


    Exam.prototype.render = function render(jsonString, type, headerOffsetTop) {
      var _this3 = this;

      clearTimeout(this.clearContentTimer);
      var oContent = jsonString;
      if (typeof jsonString === 'string') {
        oContent = JSON.parse(jsonString);
      }
      oContent && (oContent.type = type);
      headerOffsetTop && $('body').css('paddingTop', headerOffsetTop);
      var currentTab = this.getCurrentTab(type);
      var examTabs = this.tabsBody.exam_tabs;
      // 渲染内容
      var renderContent = function renderContent(oContent) {
        _this3.dataBody = oContent;
        _this3.dataBody.exam_tabs = examTabs;
        _this3.dataBody.currentTab = currentTab;
        console.log('==this.dataBody==');
        console.log(_this3.dataBody);
        var theExamHtml = template('TheExam', _this3.dataBody);
        $('body').html(theExamHtml);
        _this3.setTabsGap();
        $('#loadingWrap').hide();
      };
      // 提示消息,渲染
      if (currentTab.show_msg) {
        renderContent(oContent);
        return;
      }
      // 清空屏幕逻辑
      if (!oContent || !oContent.datas) {
        $('body').html('');
        return;
      }
      // 找不到type重新请求
      if (!currentTab.code && examTabs.length) {
        console.log('没有找到该type...');
        var _type = examTabs[0].code;
        var cmd = 'cmd=requestRenderExam&type=' + _type + '&page=1';
        Util.executeCmd(cmd);
        return;
      }
      {
        // 整理标题内容
        var transText = function transText(oContent) {
          oContent.datas.forEach(function (data) {
            var sentence = data.sentence;
            // 将||改成下划线标签：
            // before：But is it really <b>happiness</b> that's linked to…ier cities |9| why firms there spend more on R＆D?
            // after:But is it really <b>happiness</b> that's linked to…ier cities <u>9</u> why firms there spend more on R＆D?
            var tidyText = sentence.text ? sentence.text.replace(/\|(\d+)\|/g, '<u>$1</u>') : '';
            sentence.text = tidyText;
          });
        };
        transText(oContent);
      }
      // 第一页
      if (oContent.pageInfo.currentPage === MIN_PAGE) {
        renderContent(oContent);
      } else {
        // 第二页需要在当前位置插入数据
        var itemHtml = template('item', oContent);
        $('#examList').append(itemHtml);
        this.dataBody.pageInfo = oContent.pageInfo;
      }
      $('#loadingWrap').hide();
    };

    return Exam;
  }(General);

  window.exam = new Exam();
});