'use strict';

var interpret = {
  init: function init() {
    FastClick.attach(document.body);
    var that = this;
    that.lastValue; //最后选中单词
    that.selRange; //最后选中对象
    that.isResume = false; //继续查词
    // 是否为英文字母
    var isAlpha = function isAlpha(str) {
      return (/[a-zA-Z']+/.test(str)
      );
    };
    document.addEventListener('touchend', function (event) {
      // 去掉android选择菜单
      event.preventDefault();
    });
    // 点击选中,解决iOS12以及以下点击不能选中问题
    var hammer = new Hammer(document, {});
    hammer.on('tap', function (event) {
      var clientX = event.clientX || event.center.x;
      var clientY = event.clientY || event.center.y;
      var oRange = document.caretRangeFromPoint(clientX, clientY);
      var so = oRange.startOffset;
      var eo = oRange.endOffset;
      var tr = oRange.cloneRange();
      var text = '';
      if (oRange.startContainer.data) while (so >= 1) {
        tr.setStart(oRange.startContainer, --so);
        text = tr.toString();
        if (!isAlpha(text.charAt(0))) {
          tr.setStart(oRange.startContainer, so + 1);
          break;
        }
      }
      if (oRange.endContainer.data) while (eo < oRange.endContainer.data.length) {
        tr.setEnd(oRange.endContainer, ++eo);
        text = tr.toString();
        if (!isAlpha(text.charAt(text.length - 1))) {
          tr.setEnd(oRange.endContainer, eo - 1);
          break;
        }
      }
      var word = tr.toString();
      var oTarget = event.target;
      var $target = $(oTarget);
      //忽略一些标签
      if ($target.is('body')) {
        return false;
      }
      if (word.length >= 1) {
        var s = window.getSelection();
        s.removeAllRanges();
        s.addRange(tr);
        postSelectionChange();
        event.preventDefault();
        return false;
      }
      console.log({
        word: word
      });
    });
    function postSelectionChange() {
      //所有高亮取消
      $('#sentenceContainer .bs').removeClass('bs');
      console.log('postSelectionChange');
      console.log(window.getSelection());
      var selectionWord = window.getSelection().toString();
      console.log(selectionWord);
      console.log(that.lastValue != selectionWord);
      if (selectionWord && that.lastValue != selectionWord) {
        var rect = interpret.getSelectionRect();
        // document.querySelector(".super-headword-container").innerHTML = JSON.parse(rect).content + (index++);
        that.lastValue = window.getSelection().toString();
        that.selRange = window.getSelection().getRangeAt(0);
        console.log('rect:' + rect);
        /*<android>*/
        window.jsInterface.execute('cmd=selectionChange&rect=' + rect);
        /*</android>*/
      } else {
        that.lastValue = '';
      }
    }
    // 播放例句
    $(document).on('touchend', '.btn-play', function () {
      var audioUrl = $(this).attr('data-audio');
      window.jsInterface.execute("cmd=play_sentence&audio=" + audioUrl);
      /*<jdists trigger="ios">
            window.webkit.messageHandlers.playSentence.postMessage(audioUrl)
            </jdists>*/
      console.log(audioUrl);
    });
  },
  // 客户端发送播放完毕，或停止播放请求
  doStopSentence: function doStopSentence() {
    var $pause = $('.btn-pause');
    $pause.removeClass('.btn-pause');
  },

  // done
  render: function render(json, offsetTop) {
    $('#mainContainer').hide();
    if (typeof json == 'string') {
      json = JSON.parse(json);
    }
    json.examples.forEach(function (value) {
      var arr = value.audio.split('/');
      value.filename = arr.pop().replace('.mp3', '');
    });
    // json.details && (json.collins = json.details);
    // console.log(json);
    var html = template('tpl', json);
    offsetTop && (document.querySelector('body').style.paddingTop = offsetTop + 'px');
    document.querySelector('#sentenceContainer').innerHTML = html;
    if (!!html.trim()) {
      $('#mainContainer').show();
    }
  },
  // remove
  getSelectionRect: function getSelectionRect() {
    var json = {};
    var oSelection = window.getSelection();
    if (oSelection.toString()) {
      var selectRect = oSelection.getRangeAt(0).getBoundingClientRect();
      var $sentense;
      var $selectParent = $(window.getSelection().anchorNode.parentNode);
      var $span;
      if ($selectParent.is('.sentence-wrap dt')) {
        $sentense = $selectParent;
      } else if ($selectParent.is('.sentence-wrap span')) {
        $sentense = $selectParent.parent();
        $span = $selectParent;
      } else if ($selectParent.is('.sentence-wrap b')) {
        $sentense = $selectParent.parent().parent();
        $span = $selectParent.parent();
      }
      if ($sentense) {
        json.top = $sentense.offset().top - $(window).scrollTop();
        json.left = $sentense.offset().left;
        json.right = json.left + $sentense.width();
        json.bottom = json.top + $sentense.height();
      }
      json.content = oSelection.toString();
      if (!!$sentense) {
        var $li = $sentense.parents('li');
        json.sentenseId = $li.attr('id');
        json.index = $('#sentenceContainer li').index($li);
      }
      return JSON.stringify(json);
    }
  },
  // done 取消选中
  removeSelection: function removeSelection() {
    interpret.lastValue = '';
    window.getSelection().removeAllRanges();
  },
  //done 还原选中单词
  resumeSelection: function resumeSelection() {
    interpret.isResume = true;
    window.getSelection().addRange(interpret.selRange);
  },
  // done
  setHeadGap: function setHeadGap(iGap) {
    document.querySelector('body').style.paddingTop = iGap + 'px';
  },
  doTouchEnd: function doTouchEnd() {},

  showTip: function showTip() {},
  hideTip: function hideTip() {},
  // done 设置高亮
  activeSentenceHighLight: function activeSentenceHighLight(sentenceId) {
    var $btnPlay = $('.btn-play');
    $btnPlay.removeClass('btn-pause');
    $('#' + sentenceId).addClass('btn-pause');
    $("[data-filename='" + sentenceId + "']").addClass('btn-pause');
  },
  // done 取消高亮
  negativeSentenceHighLight: function negativeSentenceHighLight() {
    var $btnPlay = $('.btn-play');
    $btnPlay.removeClass('btn-pause');
  },
  // done
  setFootGap: function setFootGap(iGap) {
    document.querySelector('body').style.paddingBottom = iGap + 'px';
  },
  //done 设置主题
  setTheme: function setTheme(theme) {
    $('body').attr('class', '').addClass(theme);
  }
};
interpret.init();